package GT::TradeFilters::LongOnly;

# Copyright 2000-2002 Raphal Hertzog, Fabien Fulhaber
# This file is distributed under the terms of the General Public License
# version 2 or (at your option) any later version.

use strict;
use vars qw(@NAMES @ISA);

use GT::TradeFilters;
use Carp::Datum;

@NAMES = ("LongOnly");
@ISA = qw(GT::TradeFilters);

=head1 GT::TradeFilters::LongOnly

This filter allows only long trades and reject short ones. This is
especially usefull for people who don't what to short the market.
Moreover, this filter is a must to find if a system perform better as a long
only system than either a short only or a long and short trading system.

=cut

sub new {
    my $type = shift;
    my $class = ref($type) || $type;
    my $args = shift;
    
    my $self = { 'args' => defined($args) ? $args : [] };
 
    return manage_object(\@NAMES, $self, $class, $self->{'args'}, '');
}

sub accept_trade {
    my ($self, $order, $i, $calc, $portfolio) = @_;
    
    if ($order->is_buy_order) {
	return 1;
    } else {
	return 0;
    }
}

