package GT::TradeFilters::ShortOnly;

# Copyright 2000-2002 Raphal Hertzog, Fabien Fulhaber
# This file is distributed under the terms of the General Public License
# version 2 or (at your option) any later version.

use strict;
use vars qw(@NAMES @ISA);

use GT::TradeFilters;
use Carp::Datum;

@NAMES = ("ShortOnly");
@ISA = qw(GT::TradeFilters);

=head1 GT::TradeFilters::ShortOnly

This filter allows only short trades and reject long ones. This filter is
a must to find if a system perform better as a short only system than
either a long only or a long and short trading system.

=cut

sub new {
    my $type = shift;
    my $class = ref($type) || $type;
    my $args = shift;
    
    my $self = { 'args' => defined($args) ? $args : [] };
 
    return manage_object(\@NAMES, $self, $class, $self->{'args'}, '');
}

sub accept_trade {
    my ($self, $order, $i, $calc, $portfolio) = @_;
    
    if ($order->is_sell_order) {
	return 1;
    } else {
	return 0;
    }
}

